c     ******************************************************************
c     *                                                                *
c     * csampNEPIntL: samples integraction length for a given
c     *              non e, gamma  particle in a given material air
c     *                                                                *
c     ******************************************************************
cc            From Epicsv7.0. this is not used from Epcis
c       I.e. this is for Air
c     *****************************************************************
      subroutine  csampNEPIntL
      implicit none
#include  "Zglobalc.h"
#include  "Zcode.h"
#include  "Ztrackp.h"
#include  "Ztrack.h"
#include  "Ztrackv.h"
#include  "Zheavyp.h"
#include  "Zelemagp.h"
#include  "Zevhnp.h"
#include  "Zevhnv.h"
#include  "Zcmuint.h"
c     **************************************************
c
      real*8 mfp, ek,  xs, et, mass, prob, path

c            
c        m.f.p (kg/m**2) = abn /xsec(mb)
c        parameter (aira=14.5, abogn=6.02e23, abn=aira*1.e28/abogn)
      real*8 abogn, toabn
      parameter (abogn=6.02d23, toabn=1.d28/abogn)
      real*8 collkgram, u,length, crossint
      real*8  eps/1.e-8/, smallxs/1.e-10/, largexs/1.e10/
      integer ica, ka, subcode, kinc, ia
      logical useInt2
      character*70 msg
      logical first/.true./
      save first
      
      if( first ) then
         call cixsec
         first = .false.
      endif

      et = TrackBefMove.p.fm.p(4)
      mass = TrackBefMove.p.mass
      ek = max(et - mass, eps)    ! avoid 0 energy.
      ka = TrackBefMove.p.code
      ica = TrackBefMove.p.charge

      call cdecayLeng(TrackBefMove, length)

      if(length .ne. Infty) then
         call csetIntInf(length, .true., 'decay')
      endif

c          collisions
c      useInt2 = IntModel .eq. 'int2' .and. 
c     *  TrackBefMove.p.fm.p(4) .lt. Elund
c       useInt2: use own xsection routine 
      useInt2 = ActiveMdl .eq. 'gheisha' .or.
     *          ActiveMdl .eq. 'dpmjet3' .or.
     *          ActiveMdl .eq. 'qgsjet2' .or.
     *          ActiveMdl .eq. 'incdpm3'

      if(useInt2) then
         if(ka .eq. kneumu .or. ka .eq. kneue) then
            useInt2 = .false.
         elseif(ka .eq. kmuon) then
            useInt2 = .false.    
         elseif(ka .eq. kgnuc ) then
            if( ActiveMdl .ne. 'qgsjet2') then
               if(ActiveMdl .eq. 'dpmjet3') then
                  useInt2 = .false.
               elseif(ica .ge. 2) then
                  useInt2 = .false.
               endif
            endif
         elseif(ka .ge.  kalfa .and. ka .le. khvymax) then
c            will not come here
            write(0,*) ' check csampNEPIntL '
            stop 9999
ccc            useInt2 = .false.
         elseif(ka .eq. komega .or. 
     *        ka  .eq. krho .or. ka .eq. kphi) then
            useInt2 = .false.
         elseif(ka .eq. kddb .or. ka .eq. knnb) then
            useInt2 = .false.
         elseif(ka .gt. ktriton .or. ka .eq. kdmes ) then
            useInt2 = .false.
         endif
      endif
      if(useInt2 .and. ActiveMdl .eq. 'dpmjet3' ) then
         useInt2 =
     *     TrackBefMove.p.fm.p(4)  .lt. 4.1  ! this is smoother
c     *     (TrackBefMove.p.fm.p(4) - TrackBefMove.p.mass)
c     *        .lt.  5.0 
c                     danger 5.0 is fixed &&&&&&&&&&
      endif

      if( useInt2 .and.  ActiveMdl .eq. 'qgsjet2' ) then
         ia = TargetMassN
         call rndc(u)
         if(u .lt.  TargetMassN - ia) then
            call cxsecQGS(TrackBefMove.p, ia+1, xs)
         else
            call cxsecQGS(TrackBefMove.p, ia, xs)
         endif
         mfp = toabn*TargetMassN/xs   ! in kg/m2
c             sample interaction length
         call rndc(u)
         collkgram=-mfp*log(u)
      elseif(useInt2 .and. ActiveMdl .eq. 'dpmjet3') then
c          use total X-section

         call ctotx(TrackBefMove.p, TargetMassN,  xs)

         mfp = toabn*TargetMassN/xs ! in kg/m2
c               sample interaction length
         call rndc(u)

         collkgram=-mfp*log(u)
      elseif(useInt2 .and.ActiveMdl .eq. 'incdpm3'  .and.
     *      ek .gt. 0.2d0 ) then
c            special for inclusive treatment.  target is always air
c         *********************************
         call cccode2hcode(TrackBefMove.p, kinc)
         xs = crossint(kinc, ek)
         mfp = toabn*TargetMassN/xs ! in kg/m2
c             sample interaction length
         call rndc(u)
         collkgram = -mfp*log(u)
c         *******************************
      elseif(useInt2 .and. ActiveMdl .eq. 'gheisha') then
c                Gheisha should be used for collisions
c                it include elastic scattering;
c                so we use different cross-sections
         call cxsecGheisha(TrackBefMove.p, 
     *        TargetMassN, TargetAtomicN, xs)

         mfp = toabn*TargetMassN/xs ! in kg/m2
c               sample interaction length
         call rndc(u)
         collkgram=-mfp*log(u)
      else
c         get mean free path for collision
         if(ka .eq. kpion .or. ka .eq. keta) then
            if(ica .ge. 0) then ! pi+, 0. 
               call cpiPlusAXsec(TargetMassN, ek, xs)
            else
               call cpiMinusAXsec(TargetMassN, ek, xs)
            endif
         elseif(ka .eq. kkaon) then
            if(ica .ge. 0) then
               call ckPlusAXsec(TargetMassN, ek, xs)
            else
               call ckMinusAXsec(TargetMassN, ek, xs)
            endif
         elseif(ka .eq. kmuon) then
            xs = smallxs
            if(MuPr .ge. 2 .and.
     *           TrackBefMove.p.fm.p(4) .gt. muPrEmin) then

               call cmuPrsmpP(TrackBefMove.p.fm.p(4), prob, path)
               collkgram = path * 10. ! kg/m^2
               call csetIntInf(collkgram, .false., 'mupair')
               xs =max( prob/toabn*TargetMassN/10., smallxs)
            endif
            if(MuBr .ge. 2 .and. 
     *           TrackBefMove.p.fm.p(4) .gt. muBrEmin) then
               
               call cmuBrsmpP(TrackBefMove.p.fm.p(4), prob, path)
               collkgram = path * 10. ! kg/m^2
               call csetIntInf(collkgram, .false., 'mubrem')
               xs =max( prob/toabn*TargetMassN/10., smallxs)
            endif
            if(MuNI .ge. 2 .and. 
     *           TrackBefMove.p.fm.p(4) .gt. muNEmin) then
               
               call cmuNsmpP(TrackBefMove.p.fm.p(4), prob, path)
               collkgram = path * 10. ! kg/m^2
               call csetIntInf(collkgram, .false., 'munuci')
               xs =max( prob/toabn*TargetMassN/10., smallxs)
            endif
            if(xs .ne. smallxs) goto 100 !  *********
         elseif(ka .eq. knuc) then
            if(TrackBefMove.p.subcode .eq. antip) then
               if(ek .ne. eps) then
                  call cpbarAXsec(TargetMassN, ek, xs)
               else
                  xs = largexs
               endif
            else
               call cprotonAXsec(TargetMassN, ek, xs)
            endif    
         elseif(ka .eq. kgnuc ) then
c          heavy xs
            subcode =TrackBefMove.p.subcode
            call cAAXsec(subcode, TargetMassN, ek, xs)
         elseif(ka .ge. kalfa .and. ka .le. khvymax) then    
c           heavy xs ; will not come here; obsolete
            call cAAXsec(Code2massN(ka), TargetMassN, ek, xs)
         elseif(ka .eq. kneumu) then
            xs= smallxs
         elseif(ka .eq. kneue) then
            xs= smallxs
         elseif(ka .eq. kdmes) then
C           d meson; use mean free path for kaon
            call ckPlusAXsec(TargetMassN, ek, xs)
         elseif(ka .eq. knnb) then
c             nn~ instant decay
            xs= smallxs
         elseif(ka .eq. kddb) then
c           dd~ instant decay
            xs= smallxs
         elseif(ka .eq. kgzai .or. ka .eq. ksigma .or.
     *     ka .eq. kbomega    ) then
c               use proton x-section            
            call cprotonAXsec(TargetMassN, ek, xs)
         elseif( ka .eq.  klambda .or. ka .eq. klambdac) then
c               use proton x-section            
            call cprotonAXsec(TargetMassN, ek, xs)
         else
            write(msg,*) ' csampNEPIntL:  strange ptcl: ka=',ka
            call cerrorMsg(msg, 0)
         endif
      endif

      if(xs .eq. smallxs) then
         collkgram = Infty
      elseif( xs .eq. largexs) then
         collkgram = 0.
      else
         mfp = toabn*TargetMassN/xs ! in kg/m2
c             sample interaction length
         call rndc(u)
         collkgram=-mfp*log(u)
      endif

      if( xs .ne. smallxs .and. 
     *  .not.Freec .and. Zfirst.pos.depth .eq. 0. ) then
         collkgram = 0.
      endif
      call csetIntInf(collkgram, .false., 'coll')
 100  continue
      if(xs .ne. smallxs) then
c              fix target
         call cfixTarget(xs)
      endif
c          knockon
      if(TrackBefMove.p.charge .ne. 0) then
         call cKnockp(TrackBefMove.p, prob, path) ! path in r.l
         if(prob .gt. 0.d0) then
            call csetIntInf(path *X0, .false., 'knock')
         else
            call csetIntInf(Infty,   .false., 'knock')
         endif
      endif
c/////////////////
c      write(*,*) ' ActivM=',ActiveMdl, ' code=',ka,
c     *        ' E=',ek, ' mfp=',mfp/10., ' Useint=',UseInt2
c      write(*,*) ' colg=',collkgram/10.,  'xs=', xs
c////////////
      end
c           initialize xsection calculation. for air
c   see details  Epics/prog/epixsec.f
c   and Epics/Doc/crossection.tex
c
c
      subroutine cixsec
      implicit none
#include "Ztrackp.h"
#include "Ztrack.h"
#include "Ztrackv.h"
c     c
      
      real*8 xs                 ! input.  cross-section for Air target
                                ! in mb
c
      integer noOfElem, nxsec
      parameter ( noOfElem = 3,  nxsec = 20 )
      real*8 shp, xsecmin, xsecstep
      parameter ( xsecmin = 10.d0, xsecstep = 10 )
      integer i, j, mbindex, jcon
      real*8  elemA(noOfElem), elemS(noOfElem, nxsec), sigma(nxsec)
      real*8  cumsigma(noOfElem, nxsec), elemZ(noOfElem)
      real*8  No(noOfElem)
      real*8  u
      data elemA/14.0d0, 16.0d0, 40.0d0/
      data   No/1.56d0, 0.42d0, 0.01d0/
      data   elemZ/7.0d0, 8.0d0, 18.0d0/

      save elemA, No, elemZ

      TargetMassN = 14.55   !  sum( Ai*Noi)  / sum (Noi )
      TargetAtomicN = 7.266  !  sum( Zi*Noi) / sum(Noi)
      TargetNucleonNo = 14   !  these two will be updated 
      TargetProtonNo =7      ! for each collision

      do j = 1, noOfElem
         shp = xsecmin          ! (say 10mb)
         do i = 1, nxsec
            call cxp2xAXsec(elemA(j), shp,elemS(j,i))
            shp = shp + xsecstep
         enddo
      enddo


      do i = 1, nxsec
         sigma(i) = 0.
         do j = 1, noOfElem
            sigma(i) = sigma(i) + No(j)* elemS(j,i)
         enddo
      enddo

      do i = 1, nxsec
         do j = 1, noOfElem
            cumsigma(j, i) =
     *           No(j)*elemS(j,i)/sigma(i)
         enddo
      enddo

      do i = 1, nxsec
         do j = 2, noOfElem
            cumsigma(j, i) = 
     *         cumsigma(j, i) + cumsigma(j-1, i)
         enddo
c          for safety
         cumsigma(noOfElem, i) = 1.0
      enddo
c  &&&&&&
c      do i = 1, nxsec
c         write(*,*) ' sigma=', sigma(i)
c         write(*,*) (cumsigma(j, i), j=1,noOfElem)
c      enddo
c  &&&&&&
      return
c     ************************************
      entry cfixTarget(xs)
c     ************************************
c             xs   xs                        xs
c      jcon = 1    0                         0
c       i          1                         nxsec
      call kfrge(sigma, 1, nxsec,  xs,  i, jcon)
      if(jcon .ne. 0 ) then
         mbindex = 1
      elseif( i .lt. nxsec - 1) then
         mbindex = i + 1
      else
         mbindex = nxsec
      endif
      call rndc(u)
      do j = 1, noOfElem
         if(u .le. cumsigma(j, mbindex))  goto 10
      enddo
 10   continue
      TargetNucleonNo = elemA(j) 
      TargetProtonNo =elemZ(j)
      end
